/*******************************************************************************
* File Name: KBD_OutPins.h  
* Version 1.50
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_KBD_OutPins_H) /* Pins KBD_OutPins_H */
#define CY_PINS_KBD_OutPins_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "KBD_OutPins_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    KBD_OutPins_Write(uint8 value) ;
void    KBD_OutPins_SetDriveMode(uint8 mode) ;
uint8   KBD_OutPins_ReadDataReg(void) ;
uint8   KBD_OutPins_Read(void) ;
uint8   KBD_OutPins_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define KBD_OutPins_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define KBD_OutPins_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define KBD_OutPins_DM_RES_UP          PIN_DM_RES_UP
#define KBD_OutPins_DM_RES_DWN         PIN_DM_RES_DWN
#define KBD_OutPins_DM_OD_LO           PIN_DM_OD_LO
#define KBD_OutPins_DM_OD_HI           PIN_DM_OD_HI
#define KBD_OutPins_DM_STRONG          PIN_DM_STRONG
#define KBD_OutPins_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define KBD_OutPins_MASK               KBD_OutPins__MASK
#define KBD_OutPins_SHIFT              KBD_OutPins__SHIFT
#define KBD_OutPins_WIDTH              3u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define KBD_OutPins_PS                     (* (reg8 *) KBD_OutPins__PS)
/* Data Register */
#define KBD_OutPins_DR                     (* (reg8 *) KBD_OutPins__DR)
/* Port Number */
#define KBD_OutPins_PRT_NUM                (* (reg8 *) KBD_OutPins__PRT) 
/* Connect to Analog Globals */                                                  
#define KBD_OutPins_AG                     (* (reg8 *) KBD_OutPins__AG)                       
/* Analog MUX bux enable */
#define KBD_OutPins_AMUX                   (* (reg8 *) KBD_OutPins__AMUX) 
/* Bidirectional Enable */                                                        
#define KBD_OutPins_BIE                    (* (reg8 *) KBD_OutPins__BIE)
/* Bit-mask for Aliased Register Access */
#define KBD_OutPins_BIT_MASK               (* (reg8 *) KBD_OutPins__BIT_MASK)
/* Bypass Enable */
#define KBD_OutPins_BYP                    (* (reg8 *) KBD_OutPins__BYP)
/* Port wide control signals */                                                   
#define KBD_OutPins_CTL                    (* (reg8 *) KBD_OutPins__CTL)
/* Drive Modes */
#define KBD_OutPins_DM0                    (* (reg8 *) KBD_OutPins__DM0) 
#define KBD_OutPins_DM1                    (* (reg8 *) KBD_OutPins__DM1)
#define KBD_OutPins_DM2                    (* (reg8 *) KBD_OutPins__DM2) 
/* Input Buffer Disable Override */
#define KBD_OutPins_INP_DIS                (* (reg8 *) KBD_OutPins__INP_DIS)
/* LCD Common or Segment Drive */
#define KBD_OutPins_LCD_COM_SEG            (* (reg8 *) KBD_OutPins__LCD_COM_SEG)
/* Enable Segment LCD */
#define KBD_OutPins_LCD_EN                 (* (reg8 *) KBD_OutPins__LCD_EN)
/* Slew Rate Control */
#define KBD_OutPins_SLW                    (* (reg8 *) KBD_OutPins__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define KBD_OutPins_PRTDSI__CAPS_SEL       (* (reg8 *) KBD_OutPins__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define KBD_OutPins_PRTDSI__DBL_SYNC_IN    (* (reg8 *) KBD_OutPins__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define KBD_OutPins_PRTDSI__OE_SEL0        (* (reg8 *) KBD_OutPins__PRTDSI__OE_SEL0) 
#define KBD_OutPins_PRTDSI__OE_SEL1        (* (reg8 *) KBD_OutPins__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define KBD_OutPins_PRTDSI__OUT_SEL0       (* (reg8 *) KBD_OutPins__PRTDSI__OUT_SEL0) 
#define KBD_OutPins_PRTDSI__OUT_SEL1       (* (reg8 *) KBD_OutPins__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define KBD_OutPins_PRTDSI__SYNC_OUT       (* (reg8 *) KBD_OutPins__PRTDSI__SYNC_OUT) 


#if defined(KBD_OutPins__INTSTAT)  /* Interrupt Registers */

    #define KBD_OutPins_INTSTAT                (* (reg8 *) KBD_OutPins__INTSTAT)
    #define KBD_OutPins_SNAP                   (* (reg8 *) KBD_OutPins__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins KBD_OutPins_H */


/* [] END OF FILE */
