/*******************************************************************************
* File Name: KBD_Pins.h  
* Version 1.50
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_KBD_Pins_H) /* Pins KBD_Pins_H */
#define CY_PINS_KBD_Pins_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "KBD_Pins_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    KBD_Pins_Write(uint8 value) ;
void    KBD_Pins_SetDriveMode(uint8 mode) ;
uint8   KBD_Pins_ReadDataReg(void) ;
uint8   KBD_Pins_Read(void) ;
uint8   KBD_Pins_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define KBD_Pins_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define KBD_Pins_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define KBD_Pins_DM_RES_UP          PIN_DM_RES_UP
#define KBD_Pins_DM_RES_DWN         PIN_DM_RES_DWN
#define KBD_Pins_DM_OD_LO           PIN_DM_OD_LO
#define KBD_Pins_DM_OD_HI           PIN_DM_OD_HI
#define KBD_Pins_DM_STRONG          PIN_DM_STRONG
#define KBD_Pins_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define KBD_Pins_MASK               KBD_Pins__MASK
#define KBD_Pins_SHIFT              KBD_Pins__SHIFT
#define KBD_Pins_WIDTH              8u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define KBD_Pins_PS                     (* (reg8 *) KBD_Pins__PS)
/* Data Register */
#define KBD_Pins_DR                     (* (reg8 *) KBD_Pins__DR)
/* Port Number */
#define KBD_Pins_PRT_NUM                (* (reg8 *) KBD_Pins__PRT) 
/* Connect to Analog Globals */                                                  
#define KBD_Pins_AG                     (* (reg8 *) KBD_Pins__AG)                       
/* Analog MUX bux enable */
#define KBD_Pins_AMUX                   (* (reg8 *) KBD_Pins__AMUX) 
/* Bidirectional Enable */                                                        
#define KBD_Pins_BIE                    (* (reg8 *) KBD_Pins__BIE)
/* Bit-mask for Aliased Register Access */
#define KBD_Pins_BIT_MASK               (* (reg8 *) KBD_Pins__BIT_MASK)
/* Bypass Enable */
#define KBD_Pins_BYP                    (* (reg8 *) KBD_Pins__BYP)
/* Port wide control signals */                                                   
#define KBD_Pins_CTL                    (* (reg8 *) KBD_Pins__CTL)
/* Drive Modes */
#define KBD_Pins_DM0                    (* (reg8 *) KBD_Pins__DM0) 
#define KBD_Pins_DM1                    (* (reg8 *) KBD_Pins__DM1)
#define KBD_Pins_DM2                    (* (reg8 *) KBD_Pins__DM2) 
/* Input Buffer Disable Override */
#define KBD_Pins_INP_DIS                (* (reg8 *) KBD_Pins__INP_DIS)
/* LCD Common or Segment Drive */
#define KBD_Pins_LCD_COM_SEG            (* (reg8 *) KBD_Pins__LCD_COM_SEG)
/* Enable Segment LCD */
#define KBD_Pins_LCD_EN                 (* (reg8 *) KBD_Pins__LCD_EN)
/* Slew Rate Control */
#define KBD_Pins_SLW                    (* (reg8 *) KBD_Pins__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define KBD_Pins_PRTDSI__CAPS_SEL       (* (reg8 *) KBD_Pins__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define KBD_Pins_PRTDSI__DBL_SYNC_IN    (* (reg8 *) KBD_Pins__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define KBD_Pins_PRTDSI__OE_SEL0        (* (reg8 *) KBD_Pins__PRTDSI__OE_SEL0) 
#define KBD_Pins_PRTDSI__OE_SEL1        (* (reg8 *) KBD_Pins__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define KBD_Pins_PRTDSI__OUT_SEL0       (* (reg8 *) KBD_Pins__PRTDSI__OUT_SEL0) 
#define KBD_Pins_PRTDSI__OUT_SEL1       (* (reg8 *) KBD_Pins__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define KBD_Pins_PRTDSI__SYNC_OUT       (* (reg8 *) KBD_Pins__PRTDSI__SYNC_OUT) 


#if defined(KBD_Pins__INTSTAT)  /* Interrupt Registers */

    #define KBD_Pins_INTSTAT                (* (reg8 *) KBD_Pins__INTSTAT)
    #define KBD_Pins_SNAP                   (* (reg8 *) KBD_Pins__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins KBD_Pins_H */


/* [] END OF FILE */
