/*******************************************************************************
* File Name: KBD_COLPins.h  
* Version 1.50
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_KBD_COLPins_H) /* Pins KBD_COLPins_H */
#define CY_PINS_KBD_COLPins_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "KBD_COLPins_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    KBD_COLPins_Write(uint8 value) ;
void    KBD_COLPins_SetDriveMode(uint8 mode) ;
uint8   KBD_COLPins_ReadDataReg(void) ;
uint8   KBD_COLPins_Read(void) ;
uint8   KBD_COLPins_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define KBD_COLPins_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define KBD_COLPins_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define KBD_COLPins_DM_RES_UP          PIN_DM_RES_UP
#define KBD_COLPins_DM_RES_DWN         PIN_DM_RES_DWN
#define KBD_COLPins_DM_OD_LO           PIN_DM_OD_LO
#define KBD_COLPins_DM_OD_HI           PIN_DM_OD_HI
#define KBD_COLPins_DM_STRONG          PIN_DM_STRONG
#define KBD_COLPins_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define KBD_COLPins_MASK               KBD_COLPins__MASK
#define KBD_COLPins_SHIFT              KBD_COLPins__SHIFT
#define KBD_COLPins_WIDTH              3u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define KBD_COLPins_PS                     (* (reg8 *) KBD_COLPins__PS)
/* Data Register */
#define KBD_COLPins_DR                     (* (reg8 *) KBD_COLPins__DR)
/* Port Number */
#define KBD_COLPins_PRT_NUM                (* (reg8 *) KBD_COLPins__PRT) 
/* Connect to Analog Globals */                                                  
#define KBD_COLPins_AG                     (* (reg8 *) KBD_COLPins__AG)                       
/* Analog MUX bux enable */
#define KBD_COLPins_AMUX                   (* (reg8 *) KBD_COLPins__AMUX) 
/* Bidirectional Enable */                                                        
#define KBD_COLPins_BIE                    (* (reg8 *) KBD_COLPins__BIE)
/* Bit-mask for Aliased Register Access */
#define KBD_COLPins_BIT_MASK               (* (reg8 *) KBD_COLPins__BIT_MASK)
/* Bypass Enable */
#define KBD_COLPins_BYP                    (* (reg8 *) KBD_COLPins__BYP)
/* Port wide control signals */                                                   
#define KBD_COLPins_CTL                    (* (reg8 *) KBD_COLPins__CTL)
/* Drive Modes */
#define KBD_COLPins_DM0                    (* (reg8 *) KBD_COLPins__DM0) 
#define KBD_COLPins_DM1                    (* (reg8 *) KBD_COLPins__DM1)
#define KBD_COLPins_DM2                    (* (reg8 *) KBD_COLPins__DM2) 
/* Input Buffer Disable Override */
#define KBD_COLPins_INP_DIS                (* (reg8 *) KBD_COLPins__INP_DIS)
/* LCD Common or Segment Drive */
#define KBD_COLPins_LCD_COM_SEG            (* (reg8 *) KBD_COLPins__LCD_COM_SEG)
/* Enable Segment LCD */
#define KBD_COLPins_LCD_EN                 (* (reg8 *) KBD_COLPins__LCD_EN)
/* Slew Rate Control */
#define KBD_COLPins_SLW                    (* (reg8 *) KBD_COLPins__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define KBD_COLPins_PRTDSI__CAPS_SEL       (* (reg8 *) KBD_COLPins__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define KBD_COLPins_PRTDSI__DBL_SYNC_IN    (* (reg8 *) KBD_COLPins__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define KBD_COLPins_PRTDSI__OE_SEL0        (* (reg8 *) KBD_COLPins__PRTDSI__OE_SEL0) 
#define KBD_COLPins_PRTDSI__OE_SEL1        (* (reg8 *) KBD_COLPins__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define KBD_COLPins_PRTDSI__OUT_SEL0       (* (reg8 *) KBD_COLPins__PRTDSI__OUT_SEL0) 
#define KBD_COLPins_PRTDSI__OUT_SEL1       (* (reg8 *) KBD_COLPins__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define KBD_COLPins_PRTDSI__SYNC_OUT       (* (reg8 *) KBD_COLPins__PRTDSI__SYNC_OUT) 


#if defined(KBD_COLPins__INTSTAT)  /* Interrupt Registers */

    #define KBD_COLPins_INTSTAT                (* (reg8 *) KBD_COLPins__INTSTAT)
    #define KBD_COLPins_SNAP                   (* (reg8 *) KBD_COLPins__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins KBD_COLPins_H */


/* [] END OF FILE */
