/*******************************************************************************
* File Name: KBD_InPins.h  
* Version 1.50
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_KBD_InPins_H) /* Pins KBD_InPins_H */
#define CY_PINS_KBD_InPins_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "KBD_InPins_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    KBD_InPins_Write(uint8 value) ;
void    KBD_InPins_SetDriveMode(uint8 mode) ;
uint8   KBD_InPins_ReadDataReg(void) ;
uint8   KBD_InPins_Read(void) ;
uint8   KBD_InPins_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define KBD_InPins_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define KBD_InPins_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define KBD_InPins_DM_RES_UP          PIN_DM_RES_UP
#define KBD_InPins_DM_RES_DWN         PIN_DM_RES_DWN
#define KBD_InPins_DM_OD_LO           PIN_DM_OD_LO
#define KBD_InPins_DM_OD_HI           PIN_DM_OD_HI
#define KBD_InPins_DM_STRONG          PIN_DM_STRONG
#define KBD_InPins_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define KBD_InPins_MASK               KBD_InPins__MASK
#define KBD_InPins_SHIFT              KBD_InPins__SHIFT
#define KBD_InPins_WIDTH              4u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define KBD_InPins_PS                     (* (reg8 *) KBD_InPins__PS)
/* Data Register */
#define KBD_InPins_DR                     (* (reg8 *) KBD_InPins__DR)
/* Port Number */
#define KBD_InPins_PRT_NUM                (* (reg8 *) KBD_InPins__PRT) 
/* Connect to Analog Globals */                                                  
#define KBD_InPins_AG                     (* (reg8 *) KBD_InPins__AG)                       
/* Analog MUX bux enable */
#define KBD_InPins_AMUX                   (* (reg8 *) KBD_InPins__AMUX) 
/* Bidirectional Enable */                                                        
#define KBD_InPins_BIE                    (* (reg8 *) KBD_InPins__BIE)
/* Bit-mask for Aliased Register Access */
#define KBD_InPins_BIT_MASK               (* (reg8 *) KBD_InPins__BIT_MASK)
/* Bypass Enable */
#define KBD_InPins_BYP                    (* (reg8 *) KBD_InPins__BYP)
/* Port wide control signals */                                                   
#define KBD_InPins_CTL                    (* (reg8 *) KBD_InPins__CTL)
/* Drive Modes */
#define KBD_InPins_DM0                    (* (reg8 *) KBD_InPins__DM0) 
#define KBD_InPins_DM1                    (* (reg8 *) KBD_InPins__DM1)
#define KBD_InPins_DM2                    (* (reg8 *) KBD_InPins__DM2) 
/* Input Buffer Disable Override */
#define KBD_InPins_INP_DIS                (* (reg8 *) KBD_InPins__INP_DIS)
/* LCD Common or Segment Drive */
#define KBD_InPins_LCD_COM_SEG            (* (reg8 *) KBD_InPins__LCD_COM_SEG)
/* Enable Segment LCD */
#define KBD_InPins_LCD_EN                 (* (reg8 *) KBD_InPins__LCD_EN)
/* Slew Rate Control */
#define KBD_InPins_SLW                    (* (reg8 *) KBD_InPins__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define KBD_InPins_PRTDSI__CAPS_SEL       (* (reg8 *) KBD_InPins__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define KBD_InPins_PRTDSI__DBL_SYNC_IN    (* (reg8 *) KBD_InPins__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define KBD_InPins_PRTDSI__OE_SEL0        (* (reg8 *) KBD_InPins__PRTDSI__OE_SEL0) 
#define KBD_InPins_PRTDSI__OE_SEL1        (* (reg8 *) KBD_InPins__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define KBD_InPins_PRTDSI__OUT_SEL0       (* (reg8 *) KBD_InPins__PRTDSI__OUT_SEL0) 
#define KBD_InPins_PRTDSI__OUT_SEL1       (* (reg8 *) KBD_InPins__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define KBD_InPins_PRTDSI__SYNC_OUT       (* (reg8 *) KBD_InPins__PRTDSI__SYNC_OUT) 


#if defined(KBD_InPins__INTSTAT)  /* Interrupt Registers */

    #define KBD_InPins_INTSTAT                (* (reg8 *) KBD_InPins__INTSTAT)
    #define KBD_InPins_SNAP                   (* (reg8 *) KBD_InPins__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins KBD_InPins_H */


/* [] END OF FILE */
