/*******************************************************************************
* File Name: KBD_ROWPins.h  
* Version 1.50
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2010, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
********************************************************************************/

#if !defined(CY_PINS_KBD_ROWPins_H) /* Pins KBD_ROWPins_H */
#define CY_PINS_KBD_ROWPins_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "KBD_ROWPins_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    KBD_ROWPins_Write(uint8 value) ;
void    KBD_ROWPins_SetDriveMode(uint8 mode) ;
uint8   KBD_ROWPins_ReadDataReg(void) ;
uint8   KBD_ROWPins_Read(void) ;
uint8   KBD_ROWPins_ClearInterrupt(void) ;

/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define KBD_ROWPins_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define KBD_ROWPins_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define KBD_ROWPins_DM_RES_UP          PIN_DM_RES_UP
#define KBD_ROWPins_DM_RES_DWN         PIN_DM_RES_DWN
#define KBD_ROWPins_DM_OD_LO           PIN_DM_OD_LO
#define KBD_ROWPins_DM_OD_HI           PIN_DM_OD_HI
#define KBD_ROWPins_DM_STRONG          PIN_DM_STRONG
#define KBD_ROWPins_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define KBD_ROWPins_MASK               KBD_ROWPins__MASK
#define KBD_ROWPins_SHIFT              KBD_ROWPins__SHIFT
#define KBD_ROWPins_WIDTH              4u

/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define KBD_ROWPins_PS                     (* (reg8 *) KBD_ROWPins__PS)
/* Data Register */
#define KBD_ROWPins_DR                     (* (reg8 *) KBD_ROWPins__DR)
/* Port Number */
#define KBD_ROWPins_PRT_NUM                (* (reg8 *) KBD_ROWPins__PRT) 
/* Connect to Analog Globals */                                                  
#define KBD_ROWPins_AG                     (* (reg8 *) KBD_ROWPins__AG)                       
/* Analog MUX bux enable */
#define KBD_ROWPins_AMUX                   (* (reg8 *) KBD_ROWPins__AMUX) 
/* Bidirectional Enable */                                                        
#define KBD_ROWPins_BIE                    (* (reg8 *) KBD_ROWPins__BIE)
/* Bit-mask for Aliased Register Access */
#define KBD_ROWPins_BIT_MASK               (* (reg8 *) KBD_ROWPins__BIT_MASK)
/* Bypass Enable */
#define KBD_ROWPins_BYP                    (* (reg8 *) KBD_ROWPins__BYP)
/* Port wide control signals */                                                   
#define KBD_ROWPins_CTL                    (* (reg8 *) KBD_ROWPins__CTL)
/* Drive Modes */
#define KBD_ROWPins_DM0                    (* (reg8 *) KBD_ROWPins__DM0) 
#define KBD_ROWPins_DM1                    (* (reg8 *) KBD_ROWPins__DM1)
#define KBD_ROWPins_DM2                    (* (reg8 *) KBD_ROWPins__DM2) 
/* Input Buffer Disable Override */
#define KBD_ROWPins_INP_DIS                (* (reg8 *) KBD_ROWPins__INP_DIS)
/* LCD Common or Segment Drive */
#define KBD_ROWPins_LCD_COM_SEG            (* (reg8 *) KBD_ROWPins__LCD_COM_SEG)
/* Enable Segment LCD */
#define KBD_ROWPins_LCD_EN                 (* (reg8 *) KBD_ROWPins__LCD_EN)
/* Slew Rate Control */
#define KBD_ROWPins_SLW                    (* (reg8 *) KBD_ROWPins__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define KBD_ROWPins_PRTDSI__CAPS_SEL       (* (reg8 *) KBD_ROWPins__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define KBD_ROWPins_PRTDSI__DBL_SYNC_IN    (* (reg8 *) KBD_ROWPins__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define KBD_ROWPins_PRTDSI__OE_SEL0        (* (reg8 *) KBD_ROWPins__PRTDSI__OE_SEL0) 
#define KBD_ROWPins_PRTDSI__OE_SEL1        (* (reg8 *) KBD_ROWPins__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define KBD_ROWPins_PRTDSI__OUT_SEL0       (* (reg8 *) KBD_ROWPins__PRTDSI__OUT_SEL0) 
#define KBD_ROWPins_PRTDSI__OUT_SEL1       (* (reg8 *) KBD_ROWPins__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define KBD_ROWPins_PRTDSI__SYNC_OUT       (* (reg8 *) KBD_ROWPins__PRTDSI__SYNC_OUT) 


#if defined(KBD_ROWPins__INTSTAT)  /* Interrupt Registers */

    #define KBD_ROWPins_INTSTAT                (* (reg8 *) KBD_ROWPins__INTSTAT)
    #define KBD_ROWPins_SNAP                   (* (reg8 *) KBD_ROWPins__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins KBD_ROWPins_H */


/* [] END OF FILE */
